SystemOrganization addCategory: #GODKernel!

Object subclass: #GODData
	instanceVariableNames: 'timestamp origin author title content tags width height layoutGrid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODKernel'!

!GODData commentStamp: 'has 10/3/2014 20:26' prior: 0!
I represent the handled data inside the GOD application.

My instance variables are: 
	author:	   	  A string, the author of the information.
	content:	  A string that contains the main information.
	height:		  An integer. My height in a web page. 
	layoutGrid:	  A matrix containing GODDatas. The grid position of the GODDatas 				 	 			        represents their place in a web page.
	origin:		  A string telling where I came from.
	tags:		  An ordered collection of strings. Keywords that describe me.
	timestamp:	  A date. My birth date. 
	title:		  A string to store my title.
	width:		  An integer. My width in a web page.
!

!GODData methodsFor: 'testing' stamp: 'has 10/3/2014 21:31'!
= anotherGODData

	"I compare if two GODDatas have the same content"

	self author = anotherGODData author
		ifFalse: [^false].
	self content = anotherGODData content
		ifFalse: [^false].
	self height = anotherGODData height
		ifFalse: [^false].
	self origin = anotherGODData origin
		ifFalse: [^false].
	self tags = anotherGODData tags
		ifFalse: [^false].
	self timestamp = anotherGODData timestamp
		ifFalse: [^false].
	self title = anotherGODData title
		ifFalse: [^false].
	self layoutGrid = anotherGODData layoutGrid
		ifFalse: [^false].	
	^true.! !

!GODData methodsFor: 'accessing' stamp: 'has 9/26/2014 23:03'!
addOnLayoutGrid: aGODData at: aRow at: aColumn

	"I add a GODData at the row x column"

	(aGODData isMemberOf: GODData)
		ifTrue: [layoutGrid at: aRow at: aColumn put: aGODData]
		ifFalse: [GODDataLayoutGridMustBeAGODData signal].! !

!GODData methodsFor: 'adding' stamp: 'has 9/20/2014 20:04'!
addTag: newTag
	"I add a new tag and returns the collection."
	(self tagExists: newTag)
	ifFalse:[tags add: newTag]
	ifTrue:[(GODDataTagAlreadyExistsError tagName: newTag) signal]! !

!GODData methodsFor: 'accessing' stamp: 'has 9/17/2014 21:52'!
author
	^ author! !

!GODData methodsFor: 'accessing' stamp: 'has 9/17/2014 21:52'!
author: aString
	author := aString! !

!GODData methodsFor: 'accessing' stamp: 'has 9/17/2014 21:53'!
content
	^ content! !

!GODData methodsFor: 'accessing' stamp: 'has 9/17/2014 21:53'!
content: aString
	content := aString! !

!GODData methodsFor: 'accessing' stamp: 'has 9/17/2014 22:13'!
height
	^ height! !

!GODData methodsFor: 'accessing' stamp: 'has 9/17/2014 22:13'!
height: anInteger
	height := anInteger! !

!GODData methodsFor: 'initialize' stamp: 'has 9/18/2014 15:40'!
initialize
	self tags: OrderedCollection new.! !

!GODData methodsFor: 'testing' stamp: 'has 9/17/2014 21:10'!
isGODData
	"True for all subclasses of GODData"

	^ true! !

!GODData methodsFor: 'testing' stamp: 'has 9/17/2014 22:32'!
isWho
	"Returns the subclass of GODData"

	^ self! !

!GODData methodsFor: 'accessing' stamp: 'has 9/26/2014 22:15'!
layoutGrid
	^ layoutGrid! !

!GODData methodsFor: 'accessing' stamp: 'has 9/26/2014 22:39'!
layoutGridRowSize: rowNumber columnSize: columnNumber

	"I create a new layoutGrid"
	layoutGrid := Matrix rows: rowNumber columns: columnNumber.! !

!GODData methodsFor: 'accessing' stamp: 'has 9/17/2014 21:47'!
origin
	^ origin! !

!GODData methodsFor: 'accessing' stamp: 'has 9/17/2014 21:48'!
origin: aString
	origin := aString! !

!GODData methodsFor: 'testing' stamp: 'has 9/18/2014 09:48'!
tagExists: aTagName
	" verify if a tag exists in the tag collection"
	tags do:[:each | (each = aTagName)
						ifTrue:[^true]].
	^false.! !

!GODData methodsFor: 'accessing' stamp: 'has 9/17/2014 21:54'!
tags
	^ tags! !

!GODData methodsFor: 'accessing' stamp: 'has 9/20/2014 19:40'!
tags: anOrderedCollectionTag
	
	(anOrderedCollectionTag isMemberOf: OrderedCollection)
		ifTrue: [tags := anOrderedCollectionTag]
		ifFalse: [GODDataTagMustBeAnOrderedCollection signal]
	! !

!GODData methodsFor: 'accessing' stamp: 'has 9/17/2014 21:38'!
timestamp
	^ timestamp! !

!GODData methodsFor: 'accessing' stamp: 'has 9/17/2014 21:43'!
timestamp: aDate
	timestamp := aDate! !

!GODData methodsFor: 'accessing' stamp: 'has 9/17/2014 21:53'!
title
	^ title! !

!GODData methodsFor: 'accessing' stamp: 'has 9/17/2014 21:52'!
title: aString
	title := aString! !

!GODData methodsFor: 'accessing' stamp: 'has 9/17/2014 22:11'!
width
	^ width! !

!GODData methodsFor: 'accessing' stamp: 'has 9/17/2014 22:12'!
width: anInteger
	width := anInteger! !
